<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>AdminLTE 3 | Blank Page</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">

  <!-- Copy thêm vào -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- Import awesome-->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">

</head>

<body class="hold-transition sidebar-mini">
  <!-- Site wrapper -->
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="index3.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>

        <!-- Messages Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-comments"></i>
            <span class="badge badge-danger navbar-badge">3</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Brad Diesel
                    <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">Call me whenever you can...</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    John Pierce
                    <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">I got your message bro</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Nora Silvester
                    <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">The subject goes here</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
          </div>
        </li>
        <!-- Notifications Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-bell"></i>
            <span class="badge badge-warning navbar-badge">15</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <span class="dropdown-item dropdown-header">15 Notifications</span>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-envelope mr-2"></i> 4 new messages
              <span class="float-right text-muted text-sm">3 mins</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-users mr-2"></i> 8 friend requests
              <span class="float-right text-muted text-sm">12 hours</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-file mr-2"></i> 3 new reports
              <span class="float-right text-muted text-sm">2 days</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="control-sidebar" data-slide="true" href="#" role="button">
            <i class="fas fa-th-large"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">AdminLTE 3</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Alexander Pierce</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="index.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v1</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="index2.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v2</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="index3.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v3</p>
                  </a>
                </li>
              </ul>
            </li>
            <li class="nav-header">EXAMPLES</li>
            <li class="nav-item">
              <a href="voucher.html" class="nav-link">
                <i class="nav-icon far fa-calendar-alt"></i>
                <p>
                  Voucher
                  <span class="badge badge-info right">2</span>
                </p>
              </a>
            </li>
            <li class="nav-item">
              <a href="user_list.html" class="nav-link">
                <i class="nav-icon far fa-image"></i>
                <p>
                  User List
                </p>
              </a>
            </li>
            <li class="nav-item">
              <a href="Filter orders.html" class="nav-link">
                <i class="nav-icon far fa-image"></i>
                <p>
                  Filter Orders
                </p>
              </a>
            </li>
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon far fa-envelope"></i>
                <p>
                  Mailbox
                  <i class="fas fa-angle-left right"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="../mailbox/mailbox.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Inbox</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="../mailbox/compose.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Compose</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="../mailbox/read-mail.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Read</p>
                  </a>
                </li>
              </ul>
            </li>
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon fas fa-book"></i>
                <p>
                  Pages
                  <i class="fas fa-angle-left right"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="../examples/invoice.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Invoice</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="../examples/contact-us.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Contact us</p>
                  </a>
                </li>
              </ul>
            </li>
            <li class="nav-header">MISCELLANEOUS</li>
            <li class="nav-item">
              <a href="iframe.html" class="nav-link">
                <i class="nav-icon fas fa-ellipsis-h"></i>
                <p>Tabbed IFrame Plugin</p>
              </a>
            </li>
            <li class="nav-item">
              <a href="https://adminlte.io/docs/3.1/" class="nav-link">
                <i class="nav-icon fas fa-file"></i>
                <p>Documentation</p>
              </a>
            </li>
            <li class="nav-header">MULTI LEVEL EXAMPLE</li>
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="fas fa-circle nav-icon"></i>
                <p>Level 1</p>
              </a>
            </li>
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon fas fa-circle"></i>
                <p>
                  Level 1
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="#" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Level 2</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="#" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>
                      Level 2
                      <i class="right fas fa-angle-left"></i>
                    </p>
                  </a>
                  <ul class="nav nav-treeview">
                    <li class="nav-item">
                      <a href="#" class="nav-link">
                        <i class="far fa-dot-circle nav-icon"></i>
                        <p>Level 3</p>
                      </a>
                    </li>
                    <li class="nav-item">
                      <a href="#" class="nav-link">
                        <i class="far fa-dot-circle nav-icon"></i>
                        <p>Level 3</p>
                      </a>
                    </li>
                    <li class="nav-item">
                      <a href="#" class="nav-link">
                        <i class="far fa-dot-circle nav-icon"></i>
                        <p>Level 3</p>
                      </a>
                    </li>
                  </ul>
                </li>
                <li class="nav-item">
                  <a href="#" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Level 2</p>
                  </a>
                </li>
              </ul>
            </li>
            <li class="nav-header">LABELS</li>
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon far fa-circle text-danger"></i>
                <p class="text">Important</p>
              </a>
            </li>
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon far fa-circle text-warning"></i>
                <p>Warning</p>
              </a>
            </li>
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon far fa-circle text-info"></i>
                <p>Informational</p>
              </a>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <section class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1>Voucher List</h1>
            </div>
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Filter Orders</li>
              </ol>
            </div>
          </div>
        </div><!-- /.container-fluid -->
      </section>

      <!-- Main content -->
      <section class="content">
        <div class="container-fluid">
          <div class="text-center mt-2 mb-2">
            <h2>Order List</h2>
          </div>
          <div class="jumbotron container">
            <div class="row form-group">
              <div class="col-sm-5">
                <div class="col-sm-3">
                  <label for="gStatusSelect">Status</label>
                </div>
                <div class="col-sm-9">
                  <select id="gStatusSelect" class="form-control">
                  </select>
                </div>
              </div>
              <div class="col-sm-5">
                <div class="col-sm-3">
                  <label for="gPizzaTypeSelect">Pizza Type</label>
                </div>
                <div class="col-sm-9">
                  <select id="gPizzaTypeSelect" class="form-control">
                  </select>
                </div>
              </div>
              <div class="col-sm-2">
                <button id="btn-filter-order" class="btn btn-info">Filter</button>
              </div>
            </div>
          </div>

          <div class="container-fluid">
            <table class="table table-bordered table-striped table-hover" id="order-table">
              <thead>
                <tr>
                  <th>No.</th>
                  <th>Order Code</th>
                  <th>Size</th>
                  <th>Pizza Type</th>
                  <th>Drink</th>
                  <th>Price</th>
                  <th>Customer Name</th>
                  <th>Phone</th>
                  <th>Status</th>
                  <th>Action</th>
                </tr>
              </thead>
            </table>
          </div>
          <!-- Vùng Modal -->

          <!-- Create course modal -->
          <div>
            <div id="detail-order-modal" class="modal fade" tabindex="-1">
              <div class="modal-dialog">
                <div class="modal-content">
                  <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">Order Details</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                  </div>
                  <div class="modal-body">
                    <form>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="input-detail-order-code">Order code</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="input-detail-order-code" name="ordercodes" placeholder="...."
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="detail-select-combo">Pizza Combo</label>
                        </div>
                        <div class="col-sm-9">
                          <select id="detail-select-combo" class="form-control">
                            <option value="all">--All--</option>
                          </select>
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="input-size-cm">Size</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-size-cm" name="size" placeholder="..." class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="input-size-cm">Grilled-ribs</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-ribs" name="grillribs" placeholder="..." class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="detail-salad">Salad</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-salad" name="detail-salad" placeholder="..."
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="detail-pizza-type">Pizza type</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-pizza-type" name="detail-pizza-type" placeholder="..."
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="detail-voucher">Voucher</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-voucher" name="detail-pizza-type" placeholder="..."
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="detail-price">Price</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-price" name="detail-price" placeholder="..."
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="detail-discount">Discount</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-discount" name="detail-discount" placeholder="..."
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="detail-drink">Drink</label>
                        </div>
                        <div class="col-sm-9">
                          <select id="detail-drink" class="form-control">
                            <option value="all">--All--</option>
                          </select>
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="detail-amount">Amount</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-amount" name="detail-amount" placeholder="..."
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="detail-fullname">Full name</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-fullname" name="detail-fullname" placeholder="..."
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="detail-email">Email</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-email" name="detail-email" placeholder="..."
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="detail-phone">Phone</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-phone" name="detail-phone" placeholder="..."
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="detail-phone">Address</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-address" name="detail-address" placeholder="..."
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="detail-messag">Message</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-message" name="detail-message" placeholder="..."
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="ddetail-order-date">Order Date</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-order-date" name="detail-order-date" placeholder="..."
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-3">
                          <label for="ddetail-update-date">Update Date</label>
                        </div>
                        <div class="col-sm-9">
                          <input type="text" id="detail-update-date" name="detail-update-date" placeholder="..."
                            class="form-control">
                        </div>
                      </div>
                    </form>
                  </div>
                  <div class="modal-footer">
                    <div class="row form-group">
                      <div class="col-sm-6">
                        <button class="btn btn-primary" id="btn-detail-confirm">Confirm</button>
                      </div>
                      <div class="col-sm-6">
                        <button class="btn btn-info" id="btn-detail-cancel">Cancel</button>
                      </div>
                    </div>
                    <div class="row form-group">
                      <button class="btn btn-secondary" id="btn-close" data-dismiss="modal">Close</button>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
      </section>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->

    <footer class="main-footer">
      <div class="float-right d-none d-sm-block">
        <b>Version</b> 3.2.0
      </div>
      <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
    </footer>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->

  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- Copy thêm vào -->
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.min.js"></script>


</body>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // mảng orders
  var gOrderObjects = [];
  var gStt = 0;
  var gOrderCode;
  var gId;
  var gPizzaSize = ["S", "M", "L"]

  const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

  // mảng pizza Type
  var gPizzaType = [
    {
      typeId: "Seafood",
      typeName: "Seafood"
    },
    {
      typeId: "HAWAII",
      typeName: "HAWAII"
    },
    {
      typeId: "Bacon",
      typeName: "Bacon"
    }
  ];

  // mảng status
  var gStatus = [
    {
      id: "open",
      name: "Open"
    },
    {
      id: "confirmed",
      name: "Confirmed"
    },
    {
      id: "cancel",
      name: "Cancel"
    }
  ];


  const ARRAY_NAME_COL = ['Stt', 'orderCode', 'kichCo', 'loaiPizza', 'idLoaiNuocUong', 'thanhTien', 'hoTen', 'soDienThoai', 'trangThai', 'action'];
  //khai báo các cột
  const gCOL_NO = 0;
  const gCOL_ORDERCODE = 1;
  const gCOL_COMBO = 2;
  const gCOL_PIZZA_ID = 3;
  const gCOL_DRINK_ID = 4;
  const gCOL_PRICE = 5;
  const gCOL_CUSTOMER_NAME = 6;
  const gCOL_PHONE = 7;
  const gCOL_STATUS = 8;
  const gCOL_ACTION = 9;
  var gSTT = 0;

  // khởi tạo datatable  - chưa có data
  var gOrderTable = $('#order-table').DataTable({
    columns: [
      { data: ARRAY_NAME_COL[gCOL_NO] },
      { data: ARRAY_NAME_COL[gCOL_ORDERCODE] },
      { data: ARRAY_NAME_COL[gCOL_COMBO] },
      { data: ARRAY_NAME_COL[gCOL_PIZZA_ID] },
      { data: ARRAY_NAME_COL[gCOL_DRINK_ID] },
      { data: ARRAY_NAME_COL[gCOL_PRICE] },
      { data: ARRAY_NAME_COL[gCOL_CUSTOMER_NAME] },
      { data: ARRAY_NAME_COL[gCOL_PHONE] },
      { data: ARRAY_NAME_COL[gCOL_STATUS] },
      { data: ARRAY_NAME_COL[gCOL_ACTION] },
    ],
    columnDefs: [
      //định nghĩa các cột cần hiện ra
      {
        targets: gCOL_NO, //cột STT
        className: "text-center text-primary",
        /*render: function (data, type, row, meta) {
            return meta.row + meta.settings._iDisplayStart + 1; */
        render: function () {
          gStt++;
          return gStt;
        }
      }
      ,
      {
        targets: gCOL_ACTION, //cột Action
        className: "text-center",
        defaultContent: `
                  <button id= "detail-order"  <i title = 'DEATIL' class="fa-solid fa-file-circle-check" style = "cursor:pointer; border: 1px white; color: blue"></i></button> &nbsp; 
                  <button id= "delete-course" <i title = 'Delete' class="fa-solid fa-trash" style = "cursor:pointer;border: 1px white; color: red"></i></button>`,
      }
    ]
  });

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();
  //gọi hàm hiển thị danh sách đồi uống vào select (trong modal)
  getDrinkList();
  //gọi hàm hiển thị kích cỡ pizza select(trong modal)
  getPizzaSize(gPizzaSize);
  //thêm sự kiện cho nút filter
  $("#btn-filter-order").on("click", function () {
    //gọi hàm thực thi filter
    onBtnFilterOrderClick();

  })


  // 3 - U: gán sự kiện Update - khi nhấn nút edit
  $("#order-table").on("click", "#detail-order", function () {
    onBtnDetailClick(this)
  });

  // gán sự kiện cho nút Confirm (trên modal)
  $("#btn-detail-confirm").on("click", function () {
    onBtnConfirmOrderlick();
  });

  // gán sự kiện cho nút Cancel (trên modal)
  $("#btn-detail-cancel").on("click", function () {
    onBtnCancelOrderlick();
  });


  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
    "use strict";
    loadDataToPizzaTypeSelect(gPizzaType);
    loadDataToStatusSelect(gStatus);
    // lấy data từ server
    callAPIToGetOrder()
  }

  //hàm call API to get all order

  function callAPIToGetOrder() {
    $.ajax({
      url: gBASE_URL,
      type: "GET",
      dataType: 'json',
      success: function (responseObject) {
        gOrderObjects = responseObject;
        DisplayOrderToTable(responseObject);
      },
      error: function (error) {
        console.assert(error.responseText);
      }
    });
  }



  //hàm xử lý nút filter 
  function onBtnFilterOrderClick() {
    debugger;
    "use strict";
    //khai báo đối tượng chứa dữ liệu filter
    var vFilterPizzaType = {
      status: "",
      pizzaTypeId: "",
    };
    //B1 thu thập dữ liệu để filter
    getFilterFormData(vFilterPizzaType);
    //B2: validate (k cần)
    //B3: xử lý filter
    var vResultFilter = filterPizzaType(vFilterPizzaType);
    console.log(vResultFilter);
    //B4 hiển thị kết quả lọc
    if (vResultFilter.length > 0) {
      //hiện thông báo đã tìm được
      alert("Found " + vResultFilter.length + " results");
      //hiển thị danh sách dữ liệu tìm được ra table
      DisplayOrderToTable(vResultFilter);
    }
    else {
      alert("No result was found");
      return false;
    }
  }

  // Hàm xử lý sự kiện khi icon edit trên bảng đc click
  function onBtnDetailClick(paramBtnEdit) {
    "use strict";
    console.log("Button edit được click")
    // hàm dựa vào button detail (edit or delete) xác định đc id
    var vTableRow = $(paramBtnEdit).parents("tr");
    var vOrderRowData = gOrderTable.row(vTableRow).data();
    gId = vOrderRowData.id;
    gOrderCode = vOrderRowData.orderCode;

    console.log("ID lấy được: " + gId)
    console.log("Order code lấy được: " + gOrderCode)
    getOrderByCode(gOrderCode);

  }

  //Hàm xử lý khi nhấn nút confirm trên modal
  function onBtnConfirmOrderlick() {
    // khai báo đối tượng chứa user data
    var vObjectDataOrder = {
      orderCode: "",
      kichCo: "",
      duongKinh: "",
      suon: "",
      salad: "",
      loaiPizza: "",
      idVourcher: "",
      thanhTien: "",
      giamGia: "",
      idLoaiNuocUong: "",
      soLuongNuoc: "",
      hoTen: "",
      email: "",
      soDienThoai: "",
      diaChi: "",
      loiNhan: "",
      trangThai: "",
      ngayTao: "",
      ngayCapNhat: ""
    }

    // B1: Thu thập dữ liệu
    getUpdateOrderData(vObjectDataOrder);
    // B2: Validate update
    var vIsValidate = validateData(vObjectDataOrder);
    if (vIsValidate) {
      // B3: update order
      $.ajax({
        url: gBASE_URL + "/" + gId,
        type: "PUT",
        contentType: "application/json;charset=UTF-8",
        data: JSON.stringify(vObjectDataOrder),
        success: function (paramRes) {
          // B4: xử lý front-end
          handleUpdateOrderSuccess();
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }

  }

  //Hàm xử lý khi nhấn nút cancel trên modal
  function onBtnCancelOrderlick() {
    // khai báo đối tượng chứa user data
    var vObjectDataOrder = {
      trangThai: "cancel",
      ngayCapNhat: ""
    }

    // B1: Thu thập dữ liệu
    // B2: Validate update
    // B3: Update status to Cancel order
    $.ajax({
      url: gBASE_URL + "/" + gId,
      type: "PUT",
      contentType: "application/json;charset=UTF-8",
      data: JSON.stringify(vObjectDataOrder),
      success: function (paramRes) {
        // B4: xử lý front-end
        handleCancelOrderSuccess();
      },
      error: function (paramErr) {
        console.log(paramErr.status);
      }
    });
  }



  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // hàm trả về pizzaTypeName dựa vào typeId
  /*function getPizzaNameByTypeId(paramTypeId) {
      "use strict";
      var vPizzaTypeName = "";
      var vIndex = 0;
      var vIsTypeFound = false;
      while (!vIsTypeFound && vIndex < gPizzaType.length) {
          if (gPizzaType[vIndex].typeId === paramTypeId) {
              vIsTypeFound = true;
              vPizzaTypeName = gPizzaType[vIndex].typeName;
          }
          else {
              vIndex++;
          }
      }
      return vPizzaTypeName;
  }*/



  //hàm thu thập dữ liệu để lọc
  function getFilterFormData(paramFilterObj) {
    "use strict";
    paramFilterObj.pizzaTypeId = $("#gPizzaTypeSelect").val();
    paramFilterObj.status = $("#gStatusSelect").val();
    console.log("Pizza type đã lọc là: " + paramFilterObj.pizzaTypeId + " + Status: " + paramFilterObj.status);
  }


  //hàm thực hiện lọc và hiển thị lên table
  function filterPizzaType(paramFilterObj) {
    var vResult = [];
    //thực hiện lọc
    vResult = gOrderObjects.filter(function (paramOrder) {
      if (paramOrder.loaiPizza != null) {
        return ((paramFilterObj.pizzaTypeId === "All" || paramOrder.loaiPizza.trim().toLowerCase() === paramFilterObj.pizzaTypeId.trim().toLowerCase())
          && (paramFilterObj.status === "All" || paramOrder.trangThai.trim().toLowerCase() === paramFilterObj.status.trim().toLowerCase()))
      }
    });

    return vResult;
  }



  //hàm load dữ liệu vào user table
  function DisplayOrderToTable(paramData) {
    "use strict";
    gSTT = 1; // thiết lập lại stt
    $('#order-table').DataTable().clear(); // xóa dữ liệu
    $('#order-table').DataTable().rows.add(paramData); //thêm các dòng dữ liệu vào datatable
    $('#order-table').DataTable().draw();  //vẽ lại bảng

  }



  // hàm get voucher by id
  function getOrderByCode(paramOrderCode) {
    $.ajax({
      url: gBASE_URL + "/" + gOrderCode,
      type: "GET",
      success: function (paramOrderRes) {
        showOrderDataToModal(paramOrderRes);
      },
      error: function (paramErr) {
        console.log(paramErr.status);
      }
    });
    // hiển thị modal lên
    $("#detail-order-modal").modal("show");
  }

  // hàm show order obj lên modal
  function showOrderDataToModal(paramOrderObj) {
    $("#input-detail-order-code").val(paramOrderObj.orderCode);
    $("#detail-select-combo").val(paramOrderObj.kichCo);
    $("#detail-size-cm").val(paramOrderObj.duongKinh);
    $("#detail-ribs").val(paramOrderObj.suon);
    $("#detail-salad").val(paramOrderObj.salad);
    $("#detail-pizza-type").val(paramOrderObj.loaiPizza);
    $("#detail-voucher").val(paramOrderObj.idVourcher);
    $("#detail-price").val(paramOrderObj.thanhTien);
    $("#detail-discount").val(paramOrderObj.giamGia);
    $("#detail-drink").val(paramOrderObj.idLoaiNuocUong);
    $("#detail-amount").val(paramOrderObj.soLuongNuoc);
    $("#detail-fullname").val(paramOrderObj.hoTen);
    $("#detail-email").val(paramOrderObj.email);
    $("#detail-phone").val(paramOrderObj.soDienThoai);
    $("#detail-address").val(paramOrderObj.diaChi);
    $("#detail-message").val(paramOrderObj.loiNhan);
    $("#detail-order-date").val(paramOrderObj.ngayTao);
    $("#detail-update-date").val(paramOrderObj.ngayCapNhat);
  }


  // hàm thu thập dữ liệu để update order
  function getUpdateOrderData(paramOrderObj) {
    paramOrderObj.orderCode = $("#input-detail-order-code").val().trim();
    paramOrderObj.kichCo = $("#detail-select-combo").val()
    paramOrderObj.duongKinh = parseInt($("#detail-size-cm").val());
    paramOrderObj.suon = parseInt($("#detail-ribs").val());
    paramOrderObj.salad = $("#detail-salad").val();
    paramOrderObj.loaiPizza = $("#detail-pizza-type").val();
    paramOrderObj.idVourcher = $("#detail-voucher").val().trim();
    paramOrderObj.thanhTien = parseInt($("#detail-price").val());
    paramOrderObj.giamGia = $("#detail-discount").val().trim();
    paramOrderObj.idLoaiNuocUong = $("#detail-drink").val();
    paramOrderObj.soLuongNuoc = parseInt($("#detail-amount").val().trim());
    paramOrderObj.hoTen = $("#detail-fullname").val();
    paramOrderObj.email = $("#detail-email").val().trim();
    paramOrderObj.soDienThoai = $("#detail-phone").val().trim();
    paramOrderObj.diaChi = $("#detail-address").val().trim();
    paramOrderObj.loiNhan = $("#detail-message").val();
    paramOrderObj.trangThai = "confirmed";
    paramOrderObj.ngayTao = $("#detail-order-date").val().trim();
    paramOrderObj.ngayCapNhat = $("#detail-update-date").val().trim();

  }



  // hàm validate data
  function validateData(paramOrderObj) {
    if (paramOrderObj.orderCode === "") {
      alert("Please input Order code");
      return false;
    }
    if (paramOrderObj.kichCo === "all") {
      alert("Please select Combo");
      return false;
    }
    if (paramOrderObj.thanhTien < 0 || paramOrderObj.thanhTien == 0) {
      alert("Price must be greater than 0");
      return false;
    }
    if (paramOrderObj.idLoaiNuocUong === "all") {
      alert("Please select Drink");
      return false;
    }

    return true;
  }

  //hàm confirm thành công
  function handleUpdateOrderSuccess() {
    alert("Confirmed order successfully!");
    callAPIToGetOrder();
    resertDetailOrderForm();
    $("#detail-order-modal").modal("hide");
  }

  //hàm cancel thành công
  function handleCancelOrderSuccess() {
    alert("Canceled order successfully!");
    callAPIToGetOrder();
    resertDetailOrderForm();
    $("#detail-order-modal").modal("hide");
  }

  // hàm xóa trắng form detail modal
  function resertDetailOrderForm() {
    $("#input-detail-order-code").val("");
    $("#detail-select-combo").val("");
    $("#detail-size-cm").val("");
    $("#detail-ribs").val("");
    $("#detail-salad").val("");
    $("#detail-pizza-type").val("");
    $("#detail-voucher").val("");
    $("#detail-price").val("");
    $("#detail-discount").val("");
    $("#detail-drink").val("");
    $("#detail-amount").val("");
    $("#detail-fullname").val("");
    $("#detail-email").val("");
    $("#detail-phone").val("");
    $("#detail-address").val("");
    $("#detail-message").val("");
    $("#detail-order-date").val("");
    $("#detail-update-date").val("");
  }



  //hàm load dữ liệu pizza type select
  function loadDataToPizzaTypeSelect(paramData) {
    "use strict";
    $("#gPizzaTypeSelect").append($("<option>", {
      text: "All",
      value: "All"
    }));

    for (var bI = 0; bI < paramData.length; bI++) {
      $("#gPizzaTypeSelect").append($("<option>", {
        text: paramData[bI].typeName,
        value: paramData[bI].typeId
      }));
    }
  }


  //hàm load dữ liệu status select
  function loadDataToStatusSelect(paramData) {
    "use strict";
    $("#gStatusSelect").append($("<option>", {
      text: "All",
      value: "All"
    }));

    for (var bI = 0; bI < paramData.length; bI++) {
      $("#gStatusSelect").append($("<option>", {
        text: paramData[bI].name,
        value: paramData[bI].id
      }));
    }
  }

  //hàm gọi API select drink
  function getDrinkList() {
    "use strict";
    $.ajax({
      url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
      dataType: "json",
      type: "GET",
      success: function (paramRes) {
        console.log(paramRes)
        handleDrinkList(paramRes);
      },
      error: function (paramErr) {
        console.log(paramErr.status);
      }
    });
  }



  //hàm tạo option cho select drink
  function handleDrinkList(paramDrink) {
    "use strict";
    for (var bI = 0; bI < paramDrink.length; bI++) {
      $("#detail-drink").append($("<option>", {
        text: paramDrink[bI].tenNuocUong,
        value: paramDrink[bI].maNuocUong
      }));
    }
  }

  //hàm tạo option cho select size
  function getPizzaSize(paramPizza) {
    "use strict";
    for (var bI = 0; bI < paramPizza.length; bI++) {
      $("#detail-select-combo").append($("<option>", {
        text: paramPizza[bI],
        value: paramPizza[bI]
      }));
    }
  }

</script>

</html>